%define anolis_release 3
%global __os_install_post %{nil}
%global _find_debuginfo_opts -g

Name:           bpftrace
Version:        0.16.0
Release:        %{anolis_release}%{?dist}
Summary:        High-level tracing language for Linux eBPF
License:        ASL 2.0
URL:            https://github.com/iovisor/bpftrace
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz
# https://github.com/iovisor/bpftrace/pull/2528
Patch0:         7eea7872b0c6600b69c5766ef7bdf736dd73ce9c.patch

BuildRequires:  gcc-c++ cmake llvm-devel libxml2-devel clang-devel
BuildRequires:  rubygem-asciidoctor bison flex elfutils-libelf-devel
BuildRequires:  zlib-devel bcc-devel >= 0.19.0 libbpf-devel libbpf-static
BuildRequires:  binutils-devel cereal-devel libdwarf-devel

ExclusiveArch:  x86_64 aarch64

%description
BPFtrace is a high-level tracing language for Linux enhanced Berkeley Packet
Filter (eBPF) available in recent Linux kernels (4.x). BPFtrace uses LLVM as a
backend to compile scripts to BPF-bytecode and makes use of BCC for
interacting with the Linux BPF system, as well as existing Linux tracing
capabilities: kernel dynamic tracing (kprobes), user-level dynamic tracing
(uprobes), and tracepoints. The BPFtrace language is inspired by awk and C,
and predecessor tracers such as DTrace and SystemTap

%package doc
Summary:    Documentation files for %{name}
Requires:   %{name} = %{version}-%{release}
BuildArch:  noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}

%prep
%autosetup

%build
%cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DBUILD_TESTING:BOOL=OFF \
       -DBUILD_SHARED_LIBS:BOOL=OFF \
       -DENABLE_LLVM_SHARED=1
%cmake_build


%install
%cmake_install

find %{buildroot}%{_datadir}/%{name}/tools -type f -exec \
  sed -i -e '1s=^#!/usr/bin/env %{name}\([0-9.]\+\)\?$=#!%{_bindir}/%{name}=' {} \;

%generate_compatibility_deps

%files
%{_bindir}/%{name}
%{_bindir}/%{name}-aotrt
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/tools
%dir %{_datadir}/%{name}/tools/doc
%dir %{_datadir}/%{name}/tools/old
%attr(0755,-,-) %{_datadir}/%{name}/tools/*.bt
%attr(0755,-,-) %{_datadir}/%{name}/tools/old/*.bt
%{_datadir}/%{name}/tools/doc/*.txt

%dir %{abidir}
%{abidir}/bpftrace-aotrt-option.list
%{abidir}/bpftrace-option.list
%{_mandir}/man8/*
%license LICENSE

%files doc
%doc README.md INSTALL.md CHANGELOG.md
%doc docs/*.md

%changelog
* Fri Apr 14 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> -  0.16.0-3
- Refactor the specfile
- cmake: Raise max llvm major version to 16

* Wed Feb 15 2023 Funda Wang <fundawang@yeah.net> - 0.16.0-2
- Rebuild for llvm 15

* Fri Oct 21 2022 Xuchun Shang <xuchun.shang@alibaba-inc.com> - 0.16.0-1
- Update to version 0.16.0

* Thu May 05 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.14.1-1
- Init from upstream  version 0.14.1
